@echo off
::Note: pybat.py and pybat.bat MUST be in the same directory.

::Usage:
::    pybat.bat callpy script.py [args]
::    pybat.bat callbat filenonce batch.bat [args]

::* Copyright (c) 2008, Albert Sweigart
::* All rights reserved.
::*
::* Redistribution and use in source and binary forms, with or without
::* modification, are permitted provided that the following conditions are met:
::*     * Redistributions of source code must retain the above copyright
::*       notice, this list of conditions and the following disclaimer.
::*     * Redistributions in binary form must reproduce the above copyright
::*       notice, this list of conditions and the following disclaimer in the
::*       documentation and/or other materials provided with the distribution.
::*     * Neither the name of the PyBat nor the
::*       names of its contributors may be used to endorse or promote products
::*       derived from this software without specific prior written permission.
::*
::* THIS SOFTWARE IS PROVIDED BY Albert Sweigart ``AS IS'' AND ANY
::* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
::* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
::* DISCLAIMED. IN NO EVENT SHALL Albert Sweigart BE LIABLE FOR ANY
::* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
::* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
::* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
::* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
::* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
::* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

:: Build 1

if %1==callpy goto CallPy
if %1==callbat goto CallBat

echo POSSIBLE ERROR - pybat.bat not called with correct command.
exit /b 1


:CallPy

%PYCMD% pybat.py generatenonce
set pybatfilenonce=%ERRORLEVEL%

set pybatparams=
%PYCMD% pybat.py chopparams3 %*
set pybatexitcode=%ERRORLEVEL%
set /p pybatparams=< "pybatparamtemp%pybatexitcode%"
del pybatparamtemp%pybatexitcode%

%PYCMD% pybat.py callpy %pybatfilenonce% %pybatparams%
set pybatexitcode2=%ERRORLEVEL%

::TODO - add a if exists check here.
call envvar%pybatfilenonce%.bat
del envvar%pybatfilenonce%.bat
exit /b %pybatexitcode2%


:CallBat

set pybatparams=
%PYCMD% pybat.py chopparams4 %*
set pybatexitcode=%ERRORLEVEL%
set /p pybatparams=< "pybatparamtemp%pybatexitcode%"
del pybatparamtemp%pybatexitcode%
call %pybatparams%
set pybatexitcode2=%ERRORLEVEL%
%PYCMD% pybat.py outputenvvar %2
exit /b %pybatexitcode2%
